ADAT SEGMENT
 A dw 36
 B dw 47
 C dw 0

 sorA db 1
 sorB db 2
 sorC db 3
ADAT ENDS

;*********************************************************************
;	MACRO-K
;*********************************************************************

HexaKiir macro Szam, Sorszam
local jegyek, szamjegy, betu, tovabb, kiiras
  	mov ax, 0b800h
	mov es, ax

	mov al, Sorszam
	dec al
	mov bl, 160
	mul bl
	mov di, ax

	mov ax, Szam
	mov bx, 16		;szmrendszer alapszma
	mov dx, 0		;segd (karakter trolsa)
	mov cx, 0		;szmjegyek szma

	jegyek:
		div bx 		;ax:=dx:ax div bx, dx:=dx:ax mod bx
		cmp dx, 9
		jg betu
		szamjegy:
                  add dx, 48    ;dx-ben a szmjegy kdja
                  jmp tovabb
		betu:
                  add dx, 55
                  jmp tovabb

                tovabb:
		push dx		;verembe
		inc cx		;eggyel tbb szmjegy
		mov dx,0	;segd nullzsa

		cmp ax, 0	;ha nincs tbb szmjegy (nulla a hnyados), akkor
		jz kiiras	;kirs

	jmp jegyek

	kiiras:
		pop ax		;szmjegy a verembl
		mov es:[di], al
		add di, 2
	loop kiiras
Endm

;***************************************************************************
;	PROGRAM
;***************************************************************************

PROGRAM SEGMENT
	assume cs: program, ds: adat

	START:
	  mov ax, adat
	  mov ds, ax

	  call Torles

          HexaKiir A, sorA
          HexaKiir B, sorB

	  call BillreVar	
	  call DosbaLep	 			

;****************************************************************************
;	ELJRSOK
;****************************************************************************


Torles proc
	mov ax, 3
	int 10h
	ret
Torles endp

BillreVar proc
	mov ah, 0
 	int 16h
	ret
BillreVar endp

DosbaLep proc
	mov ax, 4c00h
	int 21h
	ret
DosbaLep endp

PROGRAM ENDS
	END START
